import java.util.Random;

/**
 Tom Austin, Arnold Suvatne
 SJSU - cs249

 MutexTester.java
 Nov 29, 2005
 */

/**
   This is a simple class to test what happens when several
   MutexProcesses run at the same time.
   @author Tom Austin
 */
public class MutexTester
{

   /**
      Runs 3 MutexProcesses and runs several requests for each.
      Each instance will have a random starting logical clock value
      of between 0 and 500.
    */
   public static void main(String[] args)
   {
      Random randomizer = new Random();
      
      MutexProcess a = new MutexProcess("AL", Math.abs(randomizer.nextInt()) % 500);
      MutexProcess b = new MutexProcess("BEN", Math.abs(randomizer.nextInt()) % 500);
      MutexProcess c = new MutexProcess("CHUCK", Math.abs(randomizer.nextInt()) % 500);
      
      a.startListenerThread();
      b.startListenerThread();
      c.startListenerThread();
      
      a.requestResource();
      b.requestResource();
      c.requestResource();
      
      //Sleep for 10 seconds.
      try
      {
         Thread.sleep(10000);
      }
      catch (InterruptedException e)
      {
         e.printStackTrace();
      }
      
      System.out.println();
      System.out.println();
      System.out.println("FINAL SCHEDULES:");
      System.out.println(a);
      System.out.println(b);
      System.out.println(c);
   }

}
